<?php

namespace Litecms\Diamondaffiliate\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class DiamondAffiliateTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Diamondaffiliate\Models\DiamondAffiliate $diamond_affiliate)
    {
        return [
            'id'                => $diamond_affiliate->getRouteKey(),
            'key'               => [
                'public'    => $diamond_affiliate->getPublicKey(),
                'route'     => $diamond_affiliate->getRouteKey(),
            ], 
            'psv'               => $diamond_affiliate->psv,
            'tsv'               => $diamond_affiliate->tsv,
            'active_customer'   => $diamond_affiliate->active_customer,
            'total_team_app'    => $diamond_affiliate->total_team_app,
            'blue_diamond'      => $diamond_affiliate->blue_diamond,
            'executive_diamond' => $diamond_affiliate->executive_diamond,
            'platinum'          => $diamond_affiliate->platinum,
            'gold'              => $diamond_affiliate->gold,
            'silver'            => $diamond_affiliate->silver,
            'gen1'              => $diamond_affiliate->gen1,
            'gen2'              => $diamond_affiliate->gen2,
            'gen3'              => $diamond_affiliate->gen3,
            'gen4'              => $diamond_affiliate->gen4,
            'gen5'              => $diamond_affiliate->gen5,
            'gen6'              => $diamond_affiliate->gen6,
            'gen7'              => $diamond_affiliate->gen7,
            'gen8'              => $diamond_affiliate->gen8,
            'gen9'              => $diamond_affiliate->gen9,
            'gen10'             => $diamond_affiliate->gen10,
            'month_team_bonus'  => $diamond_affiliate->month_team_bonus,
            'yearly_team_bonus' => $diamond_affiliate->yearly_team_bonus,
            'receive_crypto_currency' => $diamond_affiliate->receive_crypto_currency,
            'bmw_car_allowance' => $diamond_affiliate->bmw_car_allowance,
            'class_a_stock'     => $diamond_affiliate->class_a_stock,
            'url'               => [
                'public'    => trans_url('diamondaffiliate/'.$diamond_affiliate->getPublicKey()),
                'user'      => guard_url('diamondaffiliate/diamond_affiliate/'.$diamond_affiliate->getRouteKey()),
            ], 
            'status'            => trans('app.'.$diamond_affiliate->status),
            'created_at'        => format_date($diamond_affiliate->created_at),
            'updated_at'        => format_date($diamond_affiliate->updated_at),
        ];
    }
}